﻿using System;
using System.Collections.Generic;

namespace GameUtils.Input
{
    public sealed class ListenerHandle<T> : IDisposable
    {
        readonly LinkedList<IInputListener<T>> list;
        LinkedListNode<IInputListener<T>> node;

        public ListenerHandle(LinkedList<IInputListener<T>> list, LinkedListNode<IInputListener<T>> node)
        {
            this.list = list;
            this.node = node;
        }

        public void Dispose()
        {
            list.Remove(node);
            node = null;
        }
    }
}
