﻿using GameUtils.Math;

namespace GameUtils.Graphics.Data
{
    public abstract class GeometryData : ResourceData
    {
        protected internal abstract void AddArc(Arc arc);

        protected internal abstract void AddLine(Vector2 point);

        protected internal abstract void AddLines(Vector2[] points);

        protected internal abstract void BeginFigure(Vector2 point, FigureBegin begin);

        protected internal abstract void EndFigure(FigureEnd end);

        protected internal abstract void AddBezier(Bezier bezier);

        protected internal abstract void AddBeziers(Bezier[] beziers);

        protected internal abstract void Close();

        protected internal abstract void AddCurve(Vector2[] points, float tension);

        protected internal abstract void AddGeometry(Geometry geometry, GeometryCombineMode combineMode);

        protected internal abstract void AddRectangle(Rectangle rect);

        protected internal abstract void AddEllipse(Ellipse ellipse);

        protected internal abstract void Transform(Matrix2x3 matrix);
    }
}
